DECLARE SUB Hilfe ()
'-- lptdbg.bas ------------------------------------------------- >>fst'03<< -
' - Parallelport-Debugger
' - Zeigt die Register von LPT1 und LPT2 in Echtzeit an.
' - Daten- und Steuerregister koennen per Tastendruck gesteuert werden.
' - Public Domain
'-- V 20030107 ------------------------------- http://www.FrankSteinberg.de -
DECLARE SUB IOAdressen ()
DECLARE SUB Grundstellung ()
DECLARE SUB Maske ()
DECLARE SUB LPT1lesen (y%)
DECLARE SUB LPT2lesen (y%)
DECLARE SUB SollIst1 ()
DECLARE SUB SollIst2 ()
DECLARE SUB Ausgeben ()
DEFINT A-Z

DIM SHARED BA1, BA1s, BA2, BA2s, UR1, UR2, SR1, SR1s, SR2, SR2s

'I/O-Adressen der Register bestimmen
CALL IOAdressen

'Bildschirm-Maske aufbauen:
CALL Maske

'Daten so ausgeben, wie eingelesen:
CALL Grundstellung

DO

 'Tasten auswerten und auf Ausgangsregister ausgeben:
 CALL Ausgeben

 'Werte der Register von LPT1 anzeigen:
 IF BA1 THEN CALL LPT1lesen(y)

 'Ausrufungszeichen anzeigen, wenn Ausgabewert vom Input abweicht (LPT1):
 IF BA1 THEN CALL SollIst1

 'Werte der Register von LPT2 anzeigen:
 IF BA2 THEN CALL LPT2lesen(y)

 'Ausrufungszeichen anzeigen, wenn Ausgabewert vom Input abweicht (LPT2):
 IF BA2 THEN CALL SollIst2

 'Ton ausgeben, wenn ein Wert sich aendert:
 IF y2 <> y THEN SOUND 3333, 1
 y2 = y: y = 0

LOOP

SUB Ausgeben

 Taste$ = LCASE$(INKEY$)               'Taste lesen

 SELECT CASE Taste$                    'Taste auswerten
  CASE "1"
   BA1s = BA1s XOR 1: OUT BA1, BA1s    'XOR aendert jeweils ein Bit,
   BA2s = BA2s XOR 1: OUT BA2, BA2s    'XOR aendert jeweils ein Bit,
  CASE "2"                             'Zustand
   BA1s = BA1s XOR 2: OUT BA1, BA1s
   BA2s = BA2s XOR 2: OUT BA2, BA2s
  CASE "3"
   BA1s = BA1s XOR 4: OUT BA1, BA1s
   BA2s = BA2s XOR 4: OUT BA2, BA2s
  CASE "4"
   BA1s = BA1s XOR 8: OUT BA1, BA1s
   BA2s = BA2s XOR 8: OUT BA2, BA2s
  CASE "5"
   BA1s = BA1s XOR 16: OUT BA1, BA1s
   BA2s = BA2s XOR 16: OUT BA2, BA2s
  CASE "6"
   BA1s = BA1s XOR 32: OUT BA1, BA1s
   BA2s = BA2s XOR 32: OUT BA2, BA2s
  CASE "7"
   BA1s = BA1s XOR 64: OUT BA1, BA1s
   BA2s = BA2s XOR 64: OUT BA2, BA2s
  CASE "8"
   BA1s = BA1s XOR 128: OUT BA1, BA1s
   BA2s = BA2s XOR 128: OUT BA2, BA2s
  CASE "s"
   SR1s = SR1s XOR 1: OUT SR1, SR1s
   SR2s = SR2s XOR 1: OUT SR2, SR2s
  CASE "a"
   SR1s = SR1s XOR 2: OUT SR1, SR1s
   SR2s = SR2s XOR 2: OUT SR2, SR2s
  CASE "r"
   SR1s = SR1s XOR 4: OUT SR1, SR1s
   SR2s = SR2s XOR 4: OUT SR2, SR2s
  CASE "e"
   SR1s = SR1s XOR 8: OUT SR1, SR1s
   SR2s = SR2s XOR 8: OUT SR2, SR2s
  CASE "i"
   SR1s = SR1s XOR 16: OUT SR1, SR1s
   SR2s = SR2s XOR 16: OUT SR2, SR2s
  CASE "b"
   SR1s = SR1s XOR 32: OUT SR1, SR1s
   SR2s = SR2s XOR 32: OUT SR2, SR2s
  CASE "u"
   SR1s = SR1s XOR 64: OUT SR1, SR1s
   SR2s = SR2s XOR 64: OUT SR2, SR2s
  CASE "n"
   SR1s = SR1s XOR 128: OUT SR1, SR1s
   SR2s = SR2s XOR 128: OUT SR2, SR2s
  CASE "h"
   CALL Hilfe
  CASE CHR$(27)                        'Ende mit [Esc]
   COLOR 7, 0 ': LOCATE 25, 1
  END
  END SELECT

END SUB

SUB Grundstellung

BA1s = INP(BA1): OUT BA1, BA1s
BA2s = INP(BA2): OUT BA2, BA2s
UR1s = INP(UR1)
UR2s = INP(UR2)
SR1s = INP(SR1): OUT SR1, SR1s
SR2s = INP(SR2): OUT SR2, SR2s

END SUB

SUB Hilfe

COLOR 7, 1
CLS
PRINT " -----------------------------------------------------------------------------"
PRINT " Parallelport Debugger 1.0              V20030107                   >>fst'03<<"
PRINT " -----------------------------------------------------------------------------"
PRINT " Das Programm ermglicht die Steuerung und Auswertung der Ein- und Ausgnge"
PRINT " der Parallelports LPT1 und LPT2. Es besteht auerdem die Mglichkeit, die 4"
PRINT " oberen Bits des Steuerregisters zu ndern. nderungen werden in Echtzeit"
PRINT " angezeigt."
PRINT " Damit hat der Benutzer die Mglichkeit, die Eigenschaften des Parallelports"
PRINT " ausfhrlich zu testen (bidirektionalitt, Grundzustand der Eingnge) sowie"
PRINT " Signale auszugeben (Relaisplatine) oder einzulesen (Schalter)."
PRINT
PRINT " HINWEISE ZUR BEDIENUNG:"
PRINT " - Die in eckigen Klammern hervorgehobenen Buchstaben bezeichnen die Tasten,"
PRINT "   die das entsprechende Bit im Ausgangsregister ndern."
PRINT " - [Esc] beendet das Programm sofort."
PRINT " - Unabhngig vom BitWert wird ein HIGH-Pegel (ca. 5 Volt) immer in gelb"
PRINT "   darstellt, ein LOW-Pegel immer in wei. "
PRINT " - Das Programm prft stndig, welche Bits gem der Bedienung des Benutzers"
PRINT "   gesetzt sein sollen. Gibt es eine Abweichung zwischen der letzten Ausgabe"
PRINT "   und dem vom Port gelesenen Wert, erscheint ein >!<."
PRINT
PRINT " MASSE liegt an folgenden Pins: 25pol SubD = Pin 18-25, Centronics = Pin 19-30"
PRINT " -----------------------------------------------------------------------------"
PRINT " Weitere Infos zu Hard- und Software:             http://www.FrankSteinberg.de";
DO: LOOP WHILE INKEY$ = ""
COLOR 7, 0
CALL Maske


END SUB

SUB IOAdressen

 DEF SEG = 0
 BA1 = PEEK(&H408) + PEEK(&H409) * 256  'Basisadresse LPT1
 BA2 = PEEK(&H40A) + PEEK(&H40B) * 256  'Basisadresse LPT2
 DEF SEG
 UR1 = BA1 + 1                          'Adresse Status-Register LPT1
 UR2 = BA2 + 1                          'Adresse Status-Register LPT2
 SR1 = BA1 + 2                          'Adresse Steuer-Register LPT1
 SR2 = BA2 + 2                          'Adresse Steuer-Register LPT2

END SUB

SUB LPT1lesen (y)

 VG0 = 11                                'Vordergrundfarbe wenn Bit = 0
 VG1 = 11                                'Vordergrundfarbe wenn Bit = 1
 VG0v = 15                               'Vordergrundfarbe wenn 0 Volt
 VG5v = 14                               'Vordergrundfarbe wenn 5 Volt

 x = INP(BA1)                            'Datenregister LPT1 auswerten
 y = y + x
 LOCATE 4, 60
 IF x AND 1 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 5, 60
 IF x AND 2 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 6, 60
 IF x AND 4 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 7, 60
 IF x AND 8 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 8, 60
 IF x AND 16 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 9, 60
 IF x AND 32 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 10, 60
 IF x AND 64 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 11, 60
 IF x AND 128 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";

 x = INP(UR1)                            'Statusregister LPT1 auswerten
 y = y + x
 LOCATE 12, 60
 IF x AND 8 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 13, 60
 IF x AND 16 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 14, 60
 IF x AND 32 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 15, 60
 IF x AND 64 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 16, 60
 IF x AND 128 THEN COLOR VG0v, 4: PRINT "1  0V";  ELSE COLOR VG5v, 4: PRINT "0  5V";

 x = INP(SR1)                            'Steuerregister LPT1 auswerten
 y = y + x
 LOCATE 17, 60
 IF x AND 1 THEN COLOR VG0v, 1: PRINT "1  0V";  ELSE COLOR VG5v, 1: PRINT "0  5V";
 LOCATE 18, 60
 IF x AND 2 THEN COLOR VG0v, 1: PRINT "1  0V";  ELSE COLOR VG5v, 1: PRINT "0  5V";
 LOCATE 19, 60
 IF x AND 4 THEN COLOR VG5v, 1: PRINT "1  5V";  ELSE COLOR VG0v, 1: PRINT "0  0V";
 LOCATE 20, 60
 IF x AND 8 THEN COLOR VG0v, 1: PRINT "1  0V";  ELSE COLOR VG5v, 1: PRINT "0  5V";
 LOCATE 21, 60
 IF x AND 16 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";
 LOCATE 22, 60
 IF x AND 32 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";
 LOCATE 23, 60
 IF x AND 64 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";
 LOCATE 24, 60
 IF x AND 128 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";

END SUB

SUB LPT2lesen (y)

 VG0 = 11                               'Vordergrundfarbe wenn Bit = 0
 VG1 = 11                               'Vordergrundfarbe wenn Bit = 1
 VG0v = 15                              'Vordergrundfarbe wenn 0 Volt
 VG5v = 14                              'Vordergrundfarbe wenn 5 Volt

 x = INP(BA2)                           'Datenregister LPT2 auswerten
 y = y + x
 LOCATE 4, 74
 IF x AND 1 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 5, 74
 IF x AND 2 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 6, 74
 IF x AND 4 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 7, 74
 IF x AND 8 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 8, 74
 IF x AND 16 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 9, 74
 IF x AND 32 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 10, 74
 IF x AND 64 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 LOCATE 11, 74
 IF x AND 128 THEN COLOR VG5v, 0: PRINT "1  5V";  ELSE COLOR VG0v, 0: PRINT "0  0V";
 
 x = INP(UR2)                           'Statusregister LPT2 auswerten
 y = y + x
 LOCATE 12, 74
 IF x AND 8 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 13, 74
 IF x AND 16 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 14, 74
 IF x AND 32 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 15, 74
 IF x AND 64 THEN COLOR VG5v, 4: PRINT "1  5V";  ELSE COLOR VG0v, 4: PRINT "0  0V";
 LOCATE 16, 74
 IF x AND 128 THEN COLOR VG0v, 4: PRINT "1  0V";  ELSE COLOR VG5v, 4: PRINT "0  5V";
 x = INP(SR2)                           'Steuerregister LPT2 auswerten
 y = y + x
 LOCATE 17, 74
 IF x AND 1 THEN COLOR VG0v, 1: PRINT "1  0V";  ELSE COLOR VG5v, 1: PRINT "0  5V";
 LOCATE 18, 74
 IF x AND 2 THEN COLOR VG0v, 1: PRINT "1  0V";  ELSE COLOR VG5v, 1: PRINT "0  5V";
 LOCATE 19, 74
 IF x AND 4 THEN COLOR VG5v, 1: PRINT "1  5V";  ELSE COLOR VG0v, 1: PRINT "0  0V";
 LOCATE 20, 74
 IF x AND 8 THEN COLOR VG0v, 1: PRINT "1  0V";  ELSE COLOR VG5v, 1: PRINT "0  5V";
 LOCATE 21, 74
 IF x AND 16 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";
 LOCATE 22, 74
 IF x AND 32 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";
 LOCATE 23, 74
 IF x AND 64 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";
 LOCATE 24, 74
 IF x AND 128 THEN COLOR VG1, 1: PRINT "1    ";  ELSE COLOR VG0, 1: PRINT "0    ";

END SUB

SUB Maske

CLS
COLOR 0, 11
PRINT "Parallelport-Debugger  1.0           Taste [H] fr Hilfe              >>fst'03<<"
COLOR 0, 7
PRINT "                                             Pin         Bit           Bit      ";
PRINT "                          Bezeichnung     SubD/Centr       Spannung      Spanng.";
COLOR 7, 0
PRINT "Daten  -  Bit0 Wert  1      DATA [1]      Pin  2/ 2  LPT1:         LPT2:        ";
PRINT "Register  Bit1 Wert  2      DATA [2]      Pin  3/ 3  LPT1:         LPT2:        ";
PRINT "Offset 0  Bit2 Wert  4      DATA [3]      Pin  4/ 4  LPT1:         LPT2:        ";
PRINT "          Bit3 Wert  8      DATA [4]      Pin  5/ 5  LPT1:         LPT2:        ";
PRINT "=Ausgang  Bit4 Wert 16      DATA [5]      Pin  6/ 6  LPT1:         LPT2:        ";
PRINT "          Bit5 Wert 32      DATA [6]      Pin  7/ 7  LPT1:         LPT2:        ";
PRINT "          Bit6 Wert 64      DATA [7]      Pin  8/ 8  LPT1:         LPT2:        ";
PRINT "          Bit7 Wert128      DATA [8]      Pin  9/ 9  LPT1:         LPT2:        ";
COLOR 7, 4
PRINT "Status-   Bit3 Wert  8       ERROR        Pin 15/32  LPT1:         LPT2:        "
PRINT "Register  Bit4 Wert 16       SELECT       Pin 13/13  LPT1:         LPT2:        "
PRINT "Offset 1  Bit5 Wert 32    PAPER EMPTY     Pin 12/12  LPT1:         LPT2:        "
PRINT "          Bit6 Wert 64    ACKNOWLEDGE     Pin 10/10  LPT1:         LPT2:        "
PRINT "=Eingang  Bit7 Wert128        BUSY        Pin 11/11  LPT1:         LPT2:        "
COLOR 7, 1
PRINT "Steuer -  Bit0 Wert  1     [S]TROBE       Pin  1/ 1  LPT1:         LPT2:        "
PRINT "Register  Bit1 Wert  2    [A]UTO FEED     Pin 14/14  LPT1:         LPT2:        "
PRINT "Offset 2  Bit2 Wert  4   [R]ESET / INIT   Pin 16/31  LPT1:         LPT2:        "
PRINT "          Bit3 Wert  8   S[E]LECT INPUT   Pin 17/36  LPT1:         LPT2:        "
PRINT "=Ausgang  Bit4 Wert 16 [I]nterrupt enable     -      LPT1:         LPT2:        "
PRINT "          Bit5 Wert 32   [b]idirektional      -      LPT1:         LPT2:        "
PRINT "          Bit6 Wert 64    [u]ndefiniert       -      LPT1:         LPT2:        "
PRINT "          Bit7 Wert128    u[n]definiert       -      LPT1:         LPT2:        ";


'Tasten in heller Schrift:
COLOR 14, 0
LOCATE 4, 34: PRINT "[1]";
LOCATE 5, 34: PRINT "[2]";
LOCATE 6, 34: PRINT "[3]";
LOCATE 7, 34: PRINT "[4]";
LOCATE 8, 34: PRINT "[5]";
LOCATE 9, 34: PRINT "[6]";
LOCATE 10, 34: PRINT "[7]";
LOCATE 11, 34: PRINT "[8]";

COLOR 14, 1
LOCATE 17, 28: PRINT "[S]";
LOCATE 18, 27: PRINT "[A]";
LOCATE 19, 26: PRINT "[R]";
LOCATE 20, 27: PRINT "[E]";
COLOR 11
LOCATE 21, 24: PRINT "[I]";
LOCATE 22, 26: PRINT "[b]";
LOCATE 23, 27: PRINT "[u]";
LOCATE 24, 28: PRINT "[n]";

'Basisadresse(n) anzeigen:
COLOR 0, 6
LOCATE 2, 1
IF BA1 THEN PRINT "BasisAdr. LPT1 "; HEX$(BA1); " hex ";
LOCATE 3, 1
IF BA2 THEN
  PRINT "          LPT2 "; HEX$(BA2); " hex ";
 ELSE
  PRINT USING "              #### dez "; BA1;
END IF

END SUB

SUB SollIst1

SI = INP(BA1) XOR BA1s
COLOR 15, 0
LOCATE 4, 59: IF SI AND 1 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 5, 59: IF SI AND 2 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 6, 59: IF SI AND 4 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 7, 59: IF SI AND 8 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 8, 59: IF SI AND 16 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 9, 59: IF SI AND 32 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 10, 59: IF SI AND 64 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 11, 59: IF SI AND 128 THEN PRINT "!";  ELSE PRINT " ";

SI = INP(SR1) XOR SR1s
COLOR 15, 1
LOCATE 17, 59: IF SI AND 1 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 18, 59: IF SI AND 2 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 19, 59: IF SI AND 4 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 20, 59: IF SI AND 8 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 21, 59: IF SI AND 16 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 22, 59: IF SI AND 32 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 23, 59: IF SI AND 64 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 24, 59: IF SI AND 128 THEN PRINT "!";  ELSE PRINT " ";

END SUB

SUB SollIst2

SI = INP(BA2) XOR BA2s
COLOR 15, 0
LOCATE 4, 73: IF SI AND 1 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 5, 73: IF SI AND 2 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 6, 73: IF SI AND 4 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 7, 73: IF SI AND 8 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 8, 73: IF SI AND 16 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 9, 73: IF SI AND 32 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 10, 73: IF SI AND 64 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 11, 73: IF SI AND 128 THEN PRINT "!";  ELSE PRINT " ";

SI = INP(SR2) XOR SR2s
COLOR 15, 1
LOCATE 17, 73: IF SI AND 1 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 18, 73: IF SI AND 2 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 19, 73: IF SI AND 4 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 20, 73: IF SI AND 8 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 21, 73: IF SI AND 16 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 22, 73: IF SI AND 32 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 23, 73: IF SI AND 64 THEN PRINT "!";  ELSE PRINT " ";
LOCATE 24, 73: IF SI AND 128 THEN PRINT "!";  ELSE PRINT " ";

END SUB

